package daca.mvc.controller;

import java.io.IOException;
import java.util.Iterator;

import javax.servlet.RequestDispatcher;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import daca.mvc.model.ModelFacade;


public class SimpleControllerServlet extends HttpServlet {
	
	static final String OPERATION_PARAM = "op";
	
	static final String ADD_OP = "add";
	static final String LIST_OP = "list";
	
	static final String WELCOME_VIEW = "/jsp/welcome.jsp";
	static final String LIST_VIEW = "/jsp/list.jsp";
	static final String INPUT_VIEW = "/jsp/input.jsp";

	protected void service(HttpServletRequest req, HttpServletResponse res) throws ServletException, IOException {
		
		String op = req.getParameter(OPERATION_PARAM);
		
		if(op == null){ //se no requisitar operao vai para a pgina iniciall
			
			forward(WELCOME_VIEW, req, res);
			
		} else if(ADD_OP.equals(op)){ //Operao de cadastrar chama o modelo para faz-lo
			
			String name = req.getParameter("name");
			String age = req.getParameter("age");
			
			if(name == null || age == null || "".equals(name) || "".equals(age)){
				if(req.getMethod().equals("POST")){
					req.setAttribute("message", "Valores incorretos!");
				}
				forward(INPUT_VIEW, req, res);
			} else {				
				ModelFacade.getInstance().addPerson(name, Integer.parseInt(age));
				req.setAttribute("message", "Feito!");
				forward(WELCOME_VIEW, req, res);
			}
		} else if(LIST_OP.equals(op)){ //operao listar pessoas
			// pega a lista no modelo
			Iterator peoples = ModelFacade.getInstance().listPersons();
			//coloca no "saco" request
			req.setAttribute("peoples", peoples);
			//repassa para o view
			forward(LIST_VIEW, req, res);
			
		} else { //operao invlida manda para a pgina inicial com mensagem de erro
			req.setAttribute("message", "Valores incorretos!");
			forward(WELCOME_VIEW, req, res);
		}
	}
	
	void forward(String path, HttpServletRequest req, HttpServletResponse res) throws ServletException, IOException{
		RequestDispatcher dispatcher = getServletContext().getRequestDispatcher(path);
		dispatcher.forward(req, res);
	}
}
